#!/usr/bin/env python
#-*- coding: UTF-8 -*-
 
import sys
import wx
import os
import os.path
import pwd
import string
import random
from   time import strftime

USER = pwd.getpwuid(os.getuid())[0]
WILDEXEC = _('All files (*)|*')
TITLE = 'EncFSman'
VERNUM = '1.16-3'
RELEASEDATE = '2017-04-08'
IMAGEDIR = TITLE.lower() + 'images'
APPICON = TITLE.lower() + '.png'
HOMEDIR = os.path.expanduser("~")
APPPATH = os.path.dirname(sys.argv[0])
ICONPATH = os.path.join(APPPATH, IMAGEDIR)
LOCALEDIR = os.path.join(APPPATH, 'locale')
VERSION = '%s - Version %s (%s)' % (TITLE, VERNUM, USER)
URL_BASE = 'http://fme.spdns.org/'
URL_WEBSITE = URL_BASE + '%s/%s' % (TITLE.lower(), TITLE.lower())
URL_DOWNLOADWEBPAGE = URL_BASE + '%s/downloads' % (TITLE.lower())
URL_HELPWEBPAGE = URL_BASE + '%s/hilfe' % (TITLE.lower())
URL_DOWNLOADFOLDER = URL_BASE + '%s/download' % (TITLE.lower())

SEPSPACE = os.sep + ' '

RED = wx.Colour(255, 0, 0)                       # no keyring connection
GREEN = wx.Colour(0, 192, 0)                     # ready
BLACK = wx.Colour(0, 0, 0)
READONLY_COLOR = wx.SYS_COLOUR_INACTIVECAPTION

if "wxGTK" in wx.PlatformInfo:
    SCALE = 22
    PSTRING = 'wxGTK'
elif "wxMSW" in wx.PlatformInfo:
    SCALE = 16
    PSTRING = 'wxMSW'
else:
    SCALE = 48
    PSTRING = ''

BORDER = 10
GAP = 5
LRT = wx.LEFT | wx.RIGHT | wx.TOP

ACTION_LOG_SIZE =  64 * 1024

#-------------------------------------------------------------------------------------------

def searchFile(filename):
    """Given a search path, find file
    """
    filefound = False
    filepath = ''
    searchpaths = os.path.expandvars('$PATH')
    paths = searchpaths.split(os.pathsep)
    for path in paths:
        filepath = os.path.join(path, filename)
        if os.path.exists(filepath):
            filefound = True
            break
    return filefound, filepath
#-------------------------------------------------------------------------------------------

def loadIcon(iconname):
    """ small helper function to load icons """
    try:
        bitmap = wx.Bitmap('%s%s%s' % (ICONPATH, os.sep, iconname))
    except:
        bitmap = wx.NullBitmap
    return bitmap
#-------------------------------------------------------------------------------------------

def format3P(vs):                       # format values '1234765' to '1.234.765'
    vs = str(vs)
    dotpos = len(vs)

    while dotpos > 3:                   
        dotpos -= 3
        vs = '%s.%s' % (vs[0:dotpos], vs[dotpos:])
    return vs
#-------------------------------------------------------------------------------------------

def idGenerator(size=6, chars=string.ascii_uppercase + string.ascii_lowercase + string.digits):
    return ''.join(random.choice(chars) for x in range(size))
#-------------------------------------------------------------------------------------------
    