#!/usr/bin/env python
#-*- coding: UTF-8 -*-

import wx
from   .encfsmanmisc import *

hint = '''The keyring / wallet is apparently not open or there is no passphrase -
you can alternatively enter the needed passphrase here
'''

class PassphraseDialog(wx.Dialog):
    
    ID_CB_PASS = wx.NewId()
    
    def __init__(self, parent, config, mapping):
        """ place About items on dialog """
        wx.Dialog.__init__(self, parent, -1, TITLE + _(' - enter passphrase'))
        self.parent = parent
        self.mapping = mapping        
        btnadj = int(config['Gui']['norm'] == 'False')
        
        sizer = wx.BoxSizer(wx.VERTICAL)
        sb = wx.StaticBox(self, -1, _(' Passphrase for selected mapping '))
        row1 = wx.StaticBoxSizer(sb, wx.VERTICAL)
        gbsz = wx.GridBagSizer(BORDER, BORDER)
        st = wx.StaticText(self, -1, hint)
        gbsz.Add(st, wx.GBPosition(0, 0), wx.GBSpan(1, 2), wx.LEFT | wx.GROW, GAP)
        st = wx.StaticText(self, -1, _('Passphrase:'))
        gbsz.Add(st, wx.GBPosition(1, 0), wx.GBSpan(1, 1), wx.LEFT | wx.GROW, GAP)
        gbsz.AddGrowableCol(1)
        
        self.tricksizer = wx.BoxSizer(wx.VERTICAL)
        self.ctrlppp = wx.TextCtrl(self, -1, self.mapping.passphrase, style = wx.TE_PASSWORD)
        self.tricksizer.Add(self.ctrlppp, 0, wx.GROW)
        self.ctrlppn = wx.TextCtrl(self, -1, self.mapping.passphrase)
        self.ctrlppn.Hide()
        self.tricksizer.Add(self.ctrlppn, 0, wx.GROW)        
        self.Bind(wx.EVT_TEXT, self.onPassphrase, self.ctrlppn)
        self.Bind(wx.EVT_TEXT, self.onPassphrase, self.ctrlppp)
        gbsz.Add(self.tricksizer, wx.GBPosition(1, 1), wx.GBSpan(1, 1), wx.LEFT | wx.GROW, GAP)
        st = wx.StaticText(self, -1, _('Show passphrase:'))
        gbsz.Add(st, wx.GBPosition(2, 0), wx.GBSpan(1, 1), wx.LEFT | wx.GROW, GAP)
        self.cbp = wx.CheckBox(self, self.ID_CB_PASS, _(' (if checked - unhide passphrase)    '))
        gbsz.Add(self.cbp, wx.GBPosition(2, 1), wx.GBSpan(1, 1), wx.LEFT | wx.GROW, GAP)
        self.Bind(wx.EVT_CHECKBOX, self.onSwitchCtrl)
        row1.Add(gbsz, 0, wx.EXPAND | wx.ALL, GAP)
        
        self.butok = wx.Button(self, wx.ID_OK)
        self.Bind(wx.EVT_BUTTON, self.onOk, id = wx.ID_OK)
        butcancel = wx.Button(self, wx.ID_CANCEL)
        row2 = wx.BoxSizer(wx.HORIZONTAL)
        if not btnadj: row2.AddStretchSpacer()
        row2.Add(self.butok, btnadj, wx.GROW | wx.RIGHT, GAP)
        row2.Add(butcancel, btnadj, wx.GROW | wx.LEFT, GAP)

        sizer.Add(row1, 0, wx.GROW | LRT, BORDER)
        sizer.Add(row2, 0, wx.GROW | wx.ALL, BORDER)
        self.ctrlppp.SetFocus()
        self.SetSizer(sizer)
        self.Fit()
    #-------------------------------------------------------------------------------------------

    def onSwitchCtrl(self, event):
        if self.cbp.GetValue():
            self.ctrlppn.SetValue(self.ctrlppp.GetValue())
            self.ctrlppp.Hide()
            self.ctrlppn.Show()
            self.ctrlppn.SetFocus()
            self.ctrlppn.SetInsertionPointEnd()
        else:
            self.ctrlppp.SetValue(self.ctrlppn.GetValue())
            self.ctrlppn.Hide()
            self.ctrlppp.Show()
            self.ctrlppp.SetFocus()
            self.ctrlppp.SetInsertionPointEnd()
        self.tricksizer.Layout()
        self.Refresh()            
    #-------------------------------------------------------------------------------------------
                
    def onPassphrase(self, event):        
        if self.ctrlppn.IsShown():
            self.mapping.passphrase = self.ctrlppn.GetValue()
        else:
            self.mapping.passphrase = self.ctrlppp.GetValue()
    #-------------------------------------------------------------------------------------------               
        
    def onOk(self, event):
        self.EndModal(wx.ID_OK)
# - class PassphraseDialog(wx.Dialog):-----------------------------------------------------------
